<?php
require_once '../../data/constant.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../data/data_for_test.php';
require_once '../../util/for_analyze.php';
require_once '../../util/make_item.php';

//ΥեǤϡ䤴Ȥβǡɽ
session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}//ɻ
$ses_list = $_SESSION[SESSION_ADMIN];
$admin_status =$ses_list['status'];
$admin_id=$ses_list['teacher_id'];

$q_id = "";
$text_id = "";
$err_msg = "";
$txt_title = "";
$q_txt = "";
$qcnt = 0;
$detail_list = "";
$test_list = "";
//$exp_dif_txt = "";
$real_dif_sel = "";
$q_level_txt="";

if ($_GET <> null) {
	if (isset ($_GET['q_id']) && is_numeric($_GET['q_id'])) $q_id = $_GET['q_id'];
}
if ($q_id == "" || !isset($_GET['txt_title'])) {
	//ѥ᡼
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/index.php");
	exit;
}
$txt_title = $_GET['txt_title'];

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	//μºݤ٤ꤷ
	if ($_POST<>null && is_numeric($_POST['real_dif'])) {
		$question_object = new CQuestionTableAccess ();
		if (!$question_object->upDat("real_dif = ".$_POST['real_dif'], " question_id = ".$q_id, $data_object->conn)) {
			$err_msg = "<br/>"._EXAM_TEA_QUEST_DIF_REG_ERR;
		}
		$_POST = null;
	}
	$ques_analysis_object = new CQuestionAnalyze();
	if (!$ques_analysis_object->main($data_object->conn,$q_id)) {
		$err_msg = "No Data";
	} else {
		$txt_title = $_GET['txt_title'];
		$q_txt = $ques_analysis_object->getQTxt ();
//		$qcnt = $ques_analysis_object->getQueCnt ();
		$detail_list = $ques_analysis_object->getDetailList ();

//		$exp_dif_id = $ques_analysis_object->getExpDif ();
		$real_dif_id = $ques_analysis_object->getRealDif ();
		$q_level_id = $ques_analysis_object->getQLevel ();
		$level_select_object = new CCreateTxtLevelSelect($data_object->conn);
		$level_select_object->setDataForInput();
		$level_arr =$level_select_object->getBasicData ();
		$q_level_txt = $level_arr[$q_level_id];

		//٤Υ饹
		$dif_sel_object = new CCreateDifficSelect($data_object->conn);
		$dif_sel_object->setDataForInput();
		$real_dif_sel = $dif_sel_object->getPullDown("real_dif", $real_dif_id);

//		$dif_arr[0] = "";
//		$dif_arr += $dif_sel_object->getBasicData ();
//		$exp_dif_txt = $dif_arr[$exp_dif_id];

		$test_arr = $ques_analysis_object->getTestArr ();
		foreach ($test_arr as $child) {
			$qcnt++;//
			$test_list .= "<tr><td>";
			if ($admin_status == 1 || $admin_id == $child['teacher_id']) {
				$test_list .= "<a href = '../test_reg/test_eval.php?test_id=".intval($child['test_id']);
				$test_list .= "&class_id=".intval($child['class_id'])."'>";
			}
			$test_list .= htmlspecialchars($child['test_nam']);
			if ($admin_status == 1 || $admin_id == $child['teacher_id']) {
				$test_list .= "</a>";
			}
			$test_list .= "</td><td>".substr($child['test_date'],0,16);
			$test_list .= "</td><td>".$child['exp_score'];
			$test_list .= "</td><td>".$child['partici_num'];
			$test_list .= "</td><td>".$child['duration']."</td></tr>\n";
		}
	}
	$data_object->closeDB();
}

$show_data = file_get_contents(TEMPLATE_DIR.'ad_analyze/admin_answer_per_que.tpl');
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':TITLE_REP:', $txt_title, $show_data);
$show_data = str_replace(':QUES_TEXT_REP:', $q_txt, $show_data);
$show_data = str_replace(':QUEST_CNT:', $qcnt, $show_data);
$show_data = str_replace(':Q_LEVEL_REP:', $q_level_txt, $show_data);

$show_data = str_replace(':HISTGR_REP:', $detail_list, $show_data);
//$show_data = str_replace(':TEXT_ID_REP:', $text_id, $show_data);
$show_data = str_replace(':REAL_DIF_REP:', $real_dif_sel, $show_data);
$show_data = str_replace(':QID_REP:', $q_id, $show_data);

$show_data = str_replace(':DATA_LIST_REP:', $test_list, $show_data);

echo $show_data;
?>