<?php
/*2012ǯ1227
 * Ŀͤθϻʬ
 */
require_once '../../data/constant.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../data/data_for_test.php';
require_once '../../data/data_for_group.php';

require_once '../../util/for_moshi.php';
session_start();


if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}
//
$admin_nam ="";
$admin_status ="";
$admin_id="";
$ses_list = $_SESSION[SESSION_ADMIN];
$err_msg = "";

if ($ses_list['status'] == 0) {
	$admin_status =$ses_list['status'];
	$admin_id=$ses_list['teacher_id'];
	$admin_nam =$ses_list['teacher_nam'];
} else {
	$admin_status =$ses_list['status'];
	$admin_id=$ses_list['teacher_id'];
}
$moshi_id = "";
$moshi_name = "";
$moshi_com="";

$type_list = "";
$type_table = "";
$goal_score="";
$duration = "";
$avg_score = "";
$avg_dur="";

$your_avg_score = "";
$your_avg_dur = "";
$moshi_num = 0;
$your_moshi_num = 0;
$answered_time = "";
$full_score = 0;
$err_msg = "";

$moshi_history_list = "";
$best_score = 0;
$worst_score = 0;

$student_nam = "";

if (isset($_GET["moshi_id"]) && is_numeric($_GET["moshi_id"]) && isset($_GET["student_id"]) &&
		is_numeric($_GET["student_id"]) && isset($_GET["class_id"]) && is_numeric($_GET["class_id"])) {
	$moshi_id = $_GET["moshi_id"];
	$class_id = $_GET["class_id"];
	$student_id = $_GET["student_id"];
} else {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {

	$class_data_object = new CClassInfoTableAccess();
	$data = $class_data_object->getOneClass($data_object->conn, $class_id);
	if ($data == false) {
		$err_msg = "Class data was not found.";
	} else {

		if ($admin_status <>1 && $data["teacher_id"] <> $admin_id) {
			header("Content-Type: text/html; charset=EUC-JP");
			header(URL_SET."admin/login.php");
			exit;
		}
		//$class_nam = htmlspecialchars($data['class_nam'],ENT_QUOTES);
	}

	//桼̾
	$st_inc_object = new CStudentInClassAccess();
	$st_data = $st_inc_object->getAndCheckMember($data_object->conn, $class_id, $student_id);
	if (!$st_data) {
		header("Content-Type: text/html; charset=EUC-JP");
		header(URL_SET."admin/login.php");
		exit;
	}

	$student_nam = htmlspecialchars($st_data["student_nam"],ENT_QUOTES);


	$moshi_data_object = new CMoshiScoreUserAccess();
	$ana_moshi_object = new CAnaUserMoshi($student_id);
	$ana_moshi_object->main($data_object->conn,$moshi_id,$moshi_data_object);

	$ana_moshi_object->setMainInfo();
	$ana_moshi_object->setYourTotalData();

	$ana_moshi_object->addYourTotalType();

	$moshi_name = $ana_moshi_object->getMoshiName();
	$moshi_com=$ana_moshi_object->getMoshiCom();
	$type_list = $ana_moshi_object->getTypeDataList();
	foreach ($type_list as $item) {
		$type_table .= "<tr>".$item."</tr>";
	}

	$goal_score = $ana_moshi_object->getGoalScore();
	if ($goal_score == 0) $goal_score = _COMMON_NOTSET_TXT;
	$duration = $ana_moshi_object->getDuration();
	if ($duration == 0) $duration = _COMMON_NOTSET_TXT;
	$avg_score = $ana_moshi_object->getAveScore();
	$avg_dur=$ana_moshi_object->getAveDur();


	$your_avg_score = $ana_moshi_object->getYourAvgScore();
	$your_avg_score = round($your_avg_score,2);
	if (intval($goal_score)>$your_avg_score) {
		$your_avg_score = "<font color='red'>".$your_avg_score."</font>";
	}

	$your_avg_dur = $ana_moshi_object->getYourAvgDur();
	$moshi_num = $ana_moshi_object->getMoshiNum();
	$your_moshi_num = $ana_moshi_object->getYourCnt();
	//$answered_time = $ana_one_moshi_obj->getAnsweredTime();
	$full_score = $ana_moshi_object->getFullScore();

	$whole_moshi_object = new CAnsToWholeMoshiTableAccess();
	if ($whole_moshi_object->setStaticDataForUsr($data_object->conn,$moshi_id,$student_id)) {
		if ($res = $whole_moshi_object->dbFetchArr()) {
			$best_score = $res["max_score"];
			if (intval($goal_score)>$best_score) {
				$best_score = "<font color='red'>".$best_score."</font>";
			}
			$worst_score = $res["min_score"];
			if (intval($goal_score)>$worst_score) {
				$worst_score = "<font color='red'>".$worst_score."</font>";
			}
		}
		$whole_moshi_object->dbFreeResult();
	}

	if ($whole_moshi_object->setHistoryOfUser($data_object->conn,$student_id,$moshi_id)) {
		while ($res = $whole_moshi_object->dbFetchArr()) {
			$moshi_history_list .= "<tr><td>";
			$moshi_history_list .= "<a href='view_one_moshi_result.php?whole_moshi_id=";
			$moshi_history_list .=intval($res["ansto_whole_moshi_id"])."&moshi_id=".$moshi_id;

			$moshi_history_list .= "&class_id=".$class_id."&student_id=".$student_id;
			$moshi_history_list .= "'>".substr($res["moshi_time"],0,-3)."</a></td>";
			$tmp_score = intval($res["score"]);
			if ($goal_score >$tmp_score) $tmp_score = "<font color='red'>".$tmp_score."</font>";
			$moshi_history_list .="<td>".$tmp_score."</td><td>";

			$moshi_history_list .=round($res["duration"]/60,2)."</td>";
			$moshi_history_list .= "</tr>\n";
		}
		$whole_moshi_object->dbFreeResult();
	}

	$data_object->closeDB();
}

$show_data = file_get_contents(TEMPLATE_DIR.'ad_analyze/view_usr_moshi_analysis.tpl');

$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':MOSHI_NAME_REP:', $moshi_name, $show_data);
$show_data = str_replace(':MOSHI_COM_REP:', $moshi_com, $show_data);
$show_data = str_replace(':GOAL_SCORE_REP:', $goal_score, $show_data);

$show_data = str_replace(':DUR_REP:', $duration, $show_data);
$show_data = str_replace(':AVG_SCORE_REP:', round($avg_score,2), $show_data);
$show_data = str_replace(':AVG_DUR_REP:', round($avg_dur,2), $show_data);
$show_data = str_replace(':MOSHI_NUM_REP:', $moshi_num, $show_data);

$show_data = str_replace(':YOUR_BEST_REP:', $best_score, $show_data);
$show_data = str_replace(':YOUR_WORST_REP:', $worst_score, $show_data);

$show_data = str_replace(':YOUR_AVG_SCORE_REP:', $your_avg_score, $show_data);
$show_data = str_replace(':YOUR_AVG_DUR_REP:', round($your_avg_dur/60,2), $show_data);
$show_data = str_replace(':YOUR_NUM_REP:', $your_moshi_num, $show_data);
//$show_data = str_replace(':DONE_TIME:', substr($answered_time,0,-3), $show_data);

$show_data = str_replace(':TYPE_TBL_REP:', $type_table, $show_data);
$show_data = str_replace(':MOSHI_ID_REP:', $moshi_id, $show_data);
$show_data = str_replace(':FULL_SCORE_REP:', $full_score, $show_data);
//$show_data = str_replace(':ANS_LIST_REP:', $answer_list, $show_data);
$show_data = str_replace(':HISTORY_LIST_REP:', $moshi_history_list, $show_data);
$show_data = str_replace(':USR_NAM_REP:', $student_nam, $show_data);
$show_data = str_replace(':CLASS_ID_REP:', $class_id, $show_data);
$show_data = str_replace(':MOSHI_ID_REP:', $moshi_id, $show_data);


echo $show_data;
?>