<?php
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../data/data_for_test.php';

session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}
//
$admin_nam ="";
$admin_status ="";
$admin_id="";
$ses_list = $_SESSION[SESSION_ADMIN];

if ($ses_list['status'] == 0) {
	$admin_status =$ses_list['status'];
	$admin_id=$ses_list['teacher_id'];
	$admin_nam =$ses_list['teacher_nam'];
} else {
	$admin_status =$ses_list['status'];
	$admin_id=$ses_list['teacher_id'];
}

$start_id = "";
$del_flag = "";
$show_txt = "";
$err_msg = "";
$grade_arr = array();

if ($_POST <> null) {
	$del_flag = $_POST["del_flag"];
}
if ($_GET <> null) {
	$start_id = $_GET['pgid'];
}

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	//CLASSΥơ֥륪֥Ȥ
	$class_data_object = new CClassInfoTableAccess();

	if ($del_flag == "del") {
		if (count($_POST) <= 1){
			$err_msg = _EXAM_TEA_CLASSLIST_CHECK_ANY;
		} else {
			//κ
			$del_condition = "";
			/*for ($i = 0; $i < GET_NUM; $i++) {
				if ($_POST["DEL".$i] <> null || $_POST["DEL".$i] <> "") {
					$del_condition .= "class_id = ".$_POST["DEL".$i];
					$del_condition .= " OR ";
				}
			}*/
			foreach ($_POST as $child) {
				//if ($child <> null && $child <> "" && $child <> "del") {
				if (is_numeric($child)) {
					$del_condition .= "class_id = '".$class_data_object->escapeSqlString($child);
					$del_condition .= "' OR ";
				}
			}
			//Ρ OR פȤ
			$del_condition = substr($del_condition, 0, -4);

			if(!$class_data_object->delDat($del_condition, $data_object->conn)) {
				$err_msg = _EXAM_TEA_CLASS_DEL_ERR;
				$err_msg .= $class_data_object->err_msg;
			}
		}
	}
	//2012/12/22add moshi
	$class_moshi_arr = array();
	$class_moshi_object = new CMoshiPerClassAccess();
	if ($class_moshi_object->setMoshiCntPerClass($data_object->conn)) {
		while ($res = $class_moshi_object->dbFetchArr()) {
			$class_moshi_arr[$res["class_id"]] = $res["moshi_cnt"];
		}
		$class_moshi_object->dbFreeResult();
	}

	$class_pra_arr = array();
	$class_pra_obj = new CPracAnaDataAccess();
	if ($class_pra_obj->setPracTotalStatList($data_object->conn)) {
		while ($res = $class_pra_obj->dbFetchArr()) {
			$tmp_val= "0";
			if ($res["ucnt"] <> 0) {
				$tmp_val = $res["cnt"]/$res["ucnt"];
			}

			$class_pra_arr[$res["class_id"]] = round($tmp_val,2);
		}
		$class_pra_obj->dbFreeResult();
	}

	if ($start_id =="" || $start_id ==null) {
		$start_id = 0;
	}

	$grade_object= new CCreateGradeSelect($data_object->conn);
	$grade_object->setDataForInput();
	$grade_arr = $grade_object->getBasicData ();

	$data = $class_data_object->getList("*", "", $data_object->conn);

	$make_item = new get_item();
	$navi = $make_item->get_navi($start_id, count($data), GET_NUM, 'class_list.php');

//admin¤ξΤ߾ܺ٤򸫤


	if (!$data) {
		$show_txt ="<tr><td colspan='7'>"._COMMON_DB_NODATA_FOUND."</tr></td>";
	} else {
		//ԽɬפʤΤȴФ
		$data = array_splice($data, ($start_id * GET_NUM), GET_NUM);
		$i= 0;

		//ǡΥ֥Ȥ
		$teacher_data_object = new CTeacherTableAccess();

		foreach($data as $data_arr) {
			//ԤǤʤϡʬιֺ¤ʤ
			$is_owner = false;
			if ($admin_status == 1 || $data_arr['teacher_id'] == $admin_id) {
				$is_owner = true;

			}
			$show_txt .= "<tr>";
			if ($is_owner == true ) {
				$show_txt .= "<td><input type='checkbox' name = 'DEL".$i."' VALUE = '".$data_arr['class_id']."'></td>";
				$show_txt .= "<td><a href='mod_class.php?class_id=".$data_arr['class_id']."'>";
//				$show_txt.=mb_convert_encoding($data_arr['class_nam'],'EUC-JP', 'UTF-8')."</a></td>";
				$show_txt.=htmlspecialchars($data_arr['class_nam'],ENT_QUOTES)."</a></td>";
			} else {
				$show_txt .= "<td><br></td>";
//				$show_txt .= "<td>".mb_convert_encoding($data_arr['class_nam'],'EUC-JP', 'UTF-8');
				$show_txt .= "<td>".htmlspecialchars($data_arr['class_nam'],ENT_QUOTES);
				$show_txt .= "</td>";
			}
			//̾μ
			$teacher_data = $teacher_data_object->getDetailTeacherData($data_object->conn, $data_arr['teacher_id']);
			if ($teacher_data == false) {
				$show_txt .= "<td>"._COMMON_DB_NODATA_FOUND."</td>";
			} else {
//				$show_txt .= "<td>".mb_convert_encoding($teacher_data['teacher_nam'],'EUC-JP', 'UTF-8')."</td>";
				$show_txt .= "<td>".htmlspecialchars($teacher_data['teacher_nam'],ENT_QUOTES)."</td>";
			}
			$show_txt.="<td>".$grade_arr[$data_arr['grade']]."</td>";
//			$show_txt .= "<td>".mb_convert_encoding($data_arr['belong'],'EUC-JP', 'UTF-8')."</td>";
			$show_txt .= "<td>".htmlspecialchars($data_arr['belong'],ENT_QUOTES)."</td>";
//ּԿ򥯥åȡּԽ̤
			if ($is_owner == true) {
				$show_txt.="<td><a href='class_mem_list.php?class_id=".$data_arr['class_id']."'>";
				$show_txt.=$data_arr['registered_num']."</a></td>";

				//2012/12/30add
				if (isset($class_pra_arr[$data_arr['class_id']])) {
				$show_txt .= "<td><a href='../analyze_reg/prac_mem_list.php?class_id=".$data_arr['class_id']."'>";
				$show_txt .= $class_pra_arr[$data_arr['class_id']]."</a></td>";
				} else {
					$show_txt .= "<td><br/></td>";
				}

				//2012/12/22add
				if (isset($class_moshi_arr[$data_arr['class_id']])) {
				$show_txt.="<td><a href='moshi_list.php?class_id=".$data_arr['class_id']."'>";
				$show_txt .= $class_moshi_arr[$data_arr['class_id']]."</a></td>";
				} else {
					$show_txt .= "<td><br/></td>";
				}

			} else {
				$show_txt .= "<td>".$data_arr['registered_num']."</td>";

				//2012/12/22add
				if (isset($class_pra_arr[$data_arr['class_id']])) {
				$show_txt .= "<td>".$class_pra_arr[$data_arr['class_id']]."</td>";
				} else {
					$show_txt .= "<td><br/></td>";
				}
				if (isset($class_moshi_arr[$data_arr['class_id']])) {
				$show_txt .= "<td>".$class_moshi_arr[$data_arr['class_id']]."</td>";
				} else {
					$show_txt .= "<td><br/></td>";
				}

			}

			if ($data_arr['status'] == 0) {
				$status_txt = _EXAM_TEA_CLASS_NOW_ENDED;
			} else if ($data_arr['status'] == 1){
				if ($is_owner == true) {
					//ξƥϿ
					$status_txt = "<a href='../test_reg/test_list.php?class_id=".$data_arr['class_id']."'>"._EXAM_TEA_CLASS_NOW_OPENING."</a>";
				} else {
					$status_txt = _EXAM_TEA_CLASS_NOW_OPENING;
				}
			} else if ($data_arr['status'] == 2) {
				$status_txt = _EXAM_TEA_CLASS_NOW_PREPARING;
			}
			$show_txt .= "<td>".$status_txt."</td></tr>\n";
			$i++;
		}
	}
	$data_object->closeDB();
}
/*
$show_data = file_get_contents('../../templates/ad_class_reg/class_list.tpl');
$show_data = ereg_replace(':ERR_MSG:', mb_convert_encoding($err_msg,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':NAV_REP:', mb_convert_encoding($navi,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':TBL_DATA:', mb_convert_encoding($show_txt,'UTF-8', 'EUC-JP'), $show_data);
*/
$show_data = file_get_contents(TEMPLATE_DIR.'ad_class_reg/class_list.tpl');
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':NAV_REP:', $navi, $show_data);
$show_data = str_replace(':TBL_DATA:', $show_txt, $show_data);

echo $show_data;

?>