<?php
require_once '../../data/constant.php';
require_once '../../util/validate.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';

session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}
$ses_arr = $_SESSION[SESSION_ADMIN];
$admin_status =$ses_arr['status'];
$admin_id=$ses_arr['teacher_id'];


if ($admin_status == 1) {
	$back_location = "<a href = 'tea_list.php'>"._EXAM_TEA_TEA_MOD_BACKTOLIST."</a>";
} else {
	$back_location = "<a href = '../index.php'>"._EXAM_TEA_TEA_MOD_BACKTOTOP."</a>";
}


$data = array();
//֤褦
$DATA_TITLE = "";
$DATA_COMMENT = "";
$DATA_CONTENT = "";
$FORMER_LOGIN = "";
$status_text = "";
$action_type = "";
$teacher_id ="";
$file_name = "mod_form.php";
$sta_chk = array (4);
$sta_chk = array_fill(0,4,"");
//GET
if ($_GET <> null) {
	$teacher_id = $_GET['teacher_id'];
	if (!is_numeric($teacher_id)) {
		header("Content-Type: text/html; charset=EUC-JP");
		header(URL_SET."admin/teacher_reg/tea_list.php");				
		exit;
	}
}
if ($_POST <> null) {
	$action_type = $_POST['action_type'];
	//2008/4/11̥桼
//	if (isset($_POST['up_id']) && is_numeric($_POST['up_id'])) $teacher_id = $_POST['up_id'];
	
}

//if ($admin_status <> 1 && $admin_id <> $teacher_id) {
if ($admin_status <> 1 && $admin_id <> $teacher_id && $teacher_id<>"") {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/index.php");				
	exit;
}
//顼åμ

$err_msg = "";
$data_object = new CDbAccess();
//DB򳫤
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	//Υǡ֥
	$teacher_data_object = new CTeacherTableAccess();

	if ($teacher_id == null || $teacher_id == "") {
		if ($action_type == "del") {
			if(!$teacher_data_object->deleteTeacherDataExe($data_object->conn, $_POST['DEL0'])) {
				$err_msg = _EXAM_TEA_TEA_DEL_ERR;
				$err_msg .= $teacher_data_object->err_msg;
				$teacher_id = $_POST['DEL0'];
				$data = $_POST;
			} else {
				header("Content-Type: text/html; charset=EUC-JP");
				if ($admin_status==1) {
				header(URL_SET."admin/teacher_reg/tea_list.php");
				} else {
				header(URL_SET."admin/index.php");				
				}
				exit;	
			}
		} else if ($action_type == "update") {

			$FORMER_LOGIN = $_POST['former_login'];

			$val_object = new validator();
			$val_object->setFormType('tea_mod');
			$val_object->setErrMsg($_POST);
			if ($val_object->err_msg == "") {
				if (!$teacher_data_object->updateTeacherDataExe($data_object->conn, $_POST)) {
					$err_msg = _EXAM_TEA_TEA_MOD_ERR;	
					$err_msg .= $teacher_data_object->err_msg;
					$data = $_POST;
					$teacher_id = $_POST['up_id'];
				} else {
				header("Content-Type: text/html; charset=EUC-JP");
				header(URL_SET."admin/teacher_reg/tea_list.php");
				exit;
				}
			} else {
				$err_msg = $val_object->err_msg;
				$data = $_POST;
				$teacher_id = $_POST['up_id'];
			}
		} else {
			header("Content-Type: text/html; charset=EUC-JP");
			header(URL_SET."admin/teacher_reg/tea_list.php");
			exit;
		}
	
	} else {
		$data = $teacher_data_object->getDetailTeacherData($data_object->conn, $teacher_id);
		if (!$data) {
			$err_msg =_COMMON_DB_NODATA_FOUND;
			$err_msg .= $teacher_data_object->err_msg;
		}
		$FORMER_LOGIN = $data['login_id'];
	}
	$data_object->closeDB();
}

$DATA_TEA_NAM = htmlspecialchars($data['teacher_nam'],ENT_QUOTES);
$DATA_LOGIN = htmlspecialchars($data['login_id'],ENT_QUOTES);
$DATA_PASS = htmlspecialchars($data['passwd'],ENT_QUOTES);
$DATA_MAIL = htmlspecialchars($data['mail_ad'],ENT_QUOTES);
$DATA_TEL = htmlspecialchars($data['tel_num'],ENT_QUOTES);
$DATA_ADDR = htmlspecialchars($data['addr'],ENT_QUOTES);
$DATA_BEL = htmlspecialchars($data['belong'],ENT_QUOTES);

$DATA_STA = $data['status'];

$DATA_COMMENT = htmlspecialchars($data['comment'],ENT_QUOTES);

if ($admin_status == 1) {
	//Ԥξˤϡơѹǽ
	//å
	if ($data['status'] == null || $data['status'] == "" || $data['status'] == "NULL") {
		$sta_chk[0] = "CHECKED";
	}
	
	for ($i =0; $i <3; $i++){
		if ($data['status'] == $i) {
			$sta_chk[$i] = "CHECKED";
		}
	}
	
	$status_text= "<tr>
		<td>"._EXAM_TEA_TEA_AUTH_TXT."</td>
		<td>
		<input type='radio' name = 'status' value=1 ".$sta_chk[1].">1. "._EXAM_TEA_TEA_ADMIN_TXT."	
		<input type='radio' name = 'status' value=2 ".$sta_chk[2].">2. "._EXAM_TEA_TEA_COMMON_TXT." 
		<input type='radio' name = 'status' value=0 ".$sta_chk[0].">3. "._EXAM_TEA_TEA_INVALID_TXT."
		</td>
	</tr>";
} else {
	$status_text= "<input type = 'hidden' name='status' value='2'/>";
}
/*
$show_data = file_get_contents('../../templates/ad_teacher_reg/mod_tea.tpl');
$show_data = ereg_replace(':ERR_MSG:', mb_convert_encoding($err_msg,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':FILE_NAME:', $file_name, $show_data);
$show_data = ereg_replace(':TEA_NAM_TXT:', mb_convert_encoding($DATA_TEA_NAM,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':LOGIN_TXT:', $DATA_LOGIN, $show_data);
$show_data = ereg_replace(':PWD_TXT:', $DATA_PASS, $show_data);
$show_data = ereg_replace(':MAIL_TXT:', $DATA_MAIL, $show_data);
$show_data = ereg_replace(':TEL_NUM_REP:', $DATA_TEL, $show_data);
$show_data = ereg_replace(':ADDR_REP:', mb_convert_encoding($DATA_ADDR,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':BELONG_REP:', mb_convert_encoding($DATA_BEL,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':COMMENT:', mb_convert_encoding($DATA_COMMENT,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':TEA_ID_REP:', $teacher_id, $show_data);
$show_data = ereg_replace(':STATUS_REP:', mb_convert_encoding($status_text,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':FORMER_LOGIN:', $FORMER_LOGIN, $show_data);
$show_data = ereg_replace(':BACK_LOC_REP:', mb_convert_encoding($back_location,'UTF-8', 'EUC-JP'), $show_data);
*/
$show_data = file_get_contents(TEMPLATE_DIR.'ad_teacher_reg/mod_tea.tpl');
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':FILE_NAME:', $file_name, $show_data);
$show_data = str_replace(':TEA_NAM_TXT:', $DATA_TEA_NAM, $show_data);
$show_data = str_replace(':LOGIN_TXT:', $DATA_LOGIN, $show_data);
$show_data = str_replace(':PWD_TXT:', $DATA_PASS, $show_data);
$show_data = str_replace(':MAIL_TXT:', $DATA_MAIL, $show_data);
$show_data = str_replace(':TEL_NUM_REP:', $DATA_TEL, $show_data);
$show_data = str_replace(':ADDR_REP:', $DATA_ADDR, $show_data);
$show_data = str_replace(':BELONG_REP:', $DATA_BEL, $show_data);
$show_data = str_replace(':COMMENT:', $DATA_COMMENT, $show_data);
$show_data = str_replace(':TEA_ID_REP:', $teacher_id, $show_data);
$show_data = str_replace(':STATUS_REP:', $status_text, $show_data);
$show_data = str_replace(':FORMER_LOGIN:', $FORMER_LOGIN, $show_data);
$show_data = str_replace(':BACK_LOC_REP:', $back_location, $show_data);

echo $show_data;
?>