<?php
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../util/post_util.php';

session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}


//
$where_st = "";
$search_txt = "";
$department_id = "";
$file_for_nave = "list.php";
$search_flag = "";

$start_id = "";
$del_flag = "";
$show_txt = "";
$err_msg = "";
$dep_pulldown = "";
$department_arr = array();
$level_arr = array();

if (isset($_POST)) {
	if (isset($_POST["DEL_FLAG"])) {
		$del_flag = $_POST["DEL_FLAG"];
	}
}
if ($_GET <> null) {
	if (isset($_GET['search_flag'])) {
		$search_flag = $_GET['search_flag'];
	}
	if (isset($_GET['pgid'])) {
		$start_id = $_GET['pgid'];
	}
}

$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {

	if ($start_id =="" || $start_id ==null) {
		$start_id = 0;
	}
	$text_data_object = new CTextTableAccess();
	
	if ($del_flag == "del") {
	//ư
		if (count($_POST) == 1){
			$err_msg = _EXAM_TEA_TXTLIST_TXTDELETE_ERR;
		} else {
			//κ
			$del_condition = "";

			foreach ($_POST as $child) {
				//if ($child <> null && $child <> "" && $child <> "del") {
				if (is_numeric($child)) {
					$del_condition .= "text_id = '".$text_data_object->escapeSqlString($child);
					$del_condition .= "' OR ";
				}	
			}
			
			//Ρ OR פȤ
			$del_condition = substr($del_condition, 0, -4);
			if(!$text_data_object->delDat($del_condition, $data_object->conn)) {
				$err_msg = _EXAM_TEA_TXTLIST_TXTDELETE_ERR;
				$err_msg .= $text_data_object->err_msg;
			}
		}
	}

	if ($search_flag == 1) {
	//ư WHERE
		if ($_GET['search_txt'] <> "" && $_GET['search_txt'] <> null) {
			$where_st .= "text_title LIKE '%".$text_data_object->escapeSqlString($_GET['search_txt'])."%'";
//			$search_txt = mb_convert_encoding($_GET['search_txt'],'EUC-JP', 'UTF-8');
			$search_txt = chPostToForm ($_GET['search_txt']);
		}
		if ($_GET['department_id'] <> 0 && is_numeric($_GET['department_id']) == true) {
			if ($where_st <> "") {
				$where_st .= " AND ";
			}
			$where_st .= "department_id = '".$text_data_object->escapeSqlString($_GET['department_id'])."'";
			$department_id = $_GET['department_id'];
		}
		if ($where_st <> "") {
			$where_st = " WHERE ".$where_st;
		}
		//$file_for_nave .= "?search_flag=1&search_txt=".urlencode($search_txt)."&department_id=".$department_id;
	}
//	$file_for_nave .= "?search_flag=".$search_flag."&search_txt=".urlencode(mb_convert_encoding($search_txt,'UTF-8', 'EUC-JP'))."&department_id=".$department_id;
	$file_for_nave .= "?search_flag=".$search_flag."&search_txt=".urlencode($search_txt)."&department_id=".$department_id;

	$dep_select_object = new CCreateDepSelect($data_object->conn);
	$dep_select_object->setDataForSearch ();
	$dep_pulldown = $dep_select_object->getPullDown ("department_id", $department_id);
	$dep_select_object->setDataForInput();
	$department_arr =$dep_select_object->getBasicData ();
	
	$level_select_object = new CCreateTxtLevelSelect($data_object->conn);
	$level_select_object->setDataForInput();
	$level_arr =$level_select_object->getBasicData ();
	
	$text_data_list = $text_data_object->getList("*", $where_st, $data_object->conn);
	$make_item = new get_item();
	$navi = $make_item->get_navi_with_search($start_id, count($text_data_list), GET_NUM, $file_for_nave);

	if ($text_data_list == false) {
		$show_txt ="<tr><td colspan=6>"._COMMON_DB_NODATA_FOUND."</tr></td>";
	} else {
		//ԽɬפʤΤȴФ
		$text_data_list = array_splice($text_data_list, ($start_id * GET_NUM), GET_NUM);
		//ɽhtmlꥹȺ

			$i= 0;
			foreach($text_data_list as $data_arr) {
				$show_txt .= "<tr>";	
				$show_txt .= "<td><input type='checkbox' name = 'DEL".$i."' VALUE = '".$data_arr['text_id']."'></td>";
//				$show_txt .= "<td><a href='mod_form.php?text_id=".$data_arr['text_id']."'>";
				$show_txt .= "<td><a href='#'onClick=\"Javascript:window.open('mod_form.php?text_id=".$data_arr['text_id']."','','width=800,height=600,status=1,toolbar=0,scrollbars=1,location=0,menubar=0,resizable=1');return false;\">";
				
				
				$show_txt.=htmlspecialchars($data_arr['text_title'],ENT_QUOTES)."</a></td>";	
				$show_txt .= "<td>".substr($data_arr['registered_date'],0,16)."</td>";	
				$show_txt .= "<td>".$department_arr[$data_arr['department_id']]."</td>";	
				$show_txt .= "<td>".$level_arr[$data_arr['level']]."</td>";					
//				$show_txt .= "<td><a href = '../question_make/insert_form.php?text_id=";
				$show_txt .= "<td><a href = '../question_make/question_list.php?text_id=";
				$show_txt .= $data_arr['text_id']."'>"._EXAM_TEA_TXTLIST_QESTEDIT_LINK."</a></td>";

				$show_txt .= "</tr>\n";
				$i++;
			}
	}
//ܤμ
/*
	$dep_select_object = new CCreateDepSelect($data_object->conn);
	$dep_select_object->setDataForSearch ();
	$dep_pulldown = $dep_select_object->getPullDown ("department_id", $department_id);
	*/
	$data_object->closeDB();
}
//$list_file_type = "ƥȡꥹ";
//$list_insert_typ = "ƥȡǡοϿ";
$list_file_type = _EXAM_TEA_TXTLIST_TITLE;
$list_insert_typ = _EXAM_TEA_TXTLIST_INSERT;

//ѥץ
//$department_object = new CCreateSelectFromMonoArr("department_id", $department_id, $DEPARTMENT_ARR);

//$show_data = file_get_contents('../../templates/ad_txt_make/data_list.tpl');
$show_data = file_get_contents(TEMPLATE_DIR.'ad_txt_make/data_list.tpl');
/*
$show_data = ereg_replace(':LIST_FILE_TYPE:', mb_convert_encoding($list_file_type,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':LIST_INSERT_TYPE:', mb_convert_encoding($list_insert_typ,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':ERR_MSG:', mb_convert_encoding($err_msg,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':NAVIGATOR:', mb_convert_encoding($navi,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':DATA_LIST:', mb_convert_encoding($show_txt,'UTF-8', 'EUC-JP'), $show_data);

$show_data = ereg_replace(':SEARCH_TXT_REP:', mb_convert_encoding($search_txt,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':DEPT_SELECT_REP:', mb_convert_encoding($department_object->pull_down_txt,'UTF-8', 'EUC-JP'), $show_data);
*/
//$show_data = ereg_replace(':PG_ID_REP:', mb_convert_encoding($start_id, 'EUC-JP'), $show_data);

$show_data = str_replace(':LIST_FILE_TYPE:', $list_file_type, $show_data);
$show_data = str_replace(':LIST_INSERT_TYPE:', $list_insert_typ, $show_data);
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':NAVIGATOR:', $navi, $show_data);
$show_data = str_replace(':DATA_LIST:', $show_txt, $show_data);
$show_data = str_replace(':SEARCH_TXT_REP:', $search_txt, $show_data);
$show_data = str_replace(':DEPT_SELECT_REP:', $dep_pulldown, $show_data);

echo $show_data;
?>