<?php
require_once '../data/constant.php';
$prefix = str_replace('test_txt_tbl','',TXT_TBL);
$prefix = addslashes($prefix);
$db_type = DB_TYPE;
$db_host = DB_HOST;
$db_name = DB_NAME;
$db_user = USR_NAME;
$db_password = USR_PWD;
$url = LOCAL_URL;
$err_msg="";
if (DB_TYPE=="mysql") {
//mySqlの場合
	$conn = mysql_connect(DB_HOST, USR_NAME, USR_PWD);
	$result = mysql_select_db(DB_NAME, $conn );
} else if (DB_TYPE=="postgres7") {
//postgresの場合
	$conn = pg_connect("host=".DB_HOST." dbname=".DB_NAME." user=".USR_NAME." password=".USR_PWD);
	if ($conn == false) {
		$result = false;
	} else {
		$result = true;
	}
}
if ($result == false) $err_msg = "CONNECT ERROR!";

if ($err_msg == "") {

	if (DB_TYPE=="mysql") {
		$sql = "CREATE TABLE ".$prefix."moshi_tbl (moshi_id bigint PRIMARY KEY AUTO_INCREMENT, moshi_name text, moshi_com text, teacher_id bigint DEFAULT NULL REFERENCES ".$prefix."teacher_tbl (teacher_id), student_id bigint DEFAULT NULL REFERENCES ".$prefix."student_tbl (student_id),difficulty int DEFAULT NULL REFERENCES ".$prefix."difficulty_tbl (difficulty_id), is_pub int DEFAULT 0,create_time datetime,update_time datetime,duration int,goal_score int,is_new int DEFAULT 1, moshi_type int, disp_type int DEFAULT 0, select_ans_type bigint) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."moshi_quiz_type_tbl (moshi_quiz_type_id bigint PRIMARY KEY AUTO_INCREMENT,score int,number int,type_com text,is_middle int,moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE CASCADE,department int REFERENCES ".$prefix."department_tbl (department_id) ON DELETE SET NULL,difficulty int REFERENCES ".$prefix."difficulty_tbl (difficulty_id) ON DELETE SET NULL,level int REFERENCES ".$prefix."txt_level_tbl (txt_level_id) ON DELETE SET NULL) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."ansto_whole_moshi_tbl (ansto_whole_moshi_id bigint PRIMARY KEY AUTO_INCREMENT,moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE SET NULL,duration int,score int,uid bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE SET NULL,moshi_time datetime) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."ind_ansto_moshi_tbl (ansto_whole_moshi_id bigint REFERENCES ".$prefix."ansto_whole_moshi_tbl(ansto_whole_moshi_id) ON DELETE SET NULL,practice_id bigint REFERENCES ".$prefix."practice_tbl(practice_id) ON DELETE SET NULL,moshi_quiz_type_id bigint REFERENCES ".$prefix."moshi_quiz_type_tbl(moshi_quiz_type_id) ON DELETE SET NULL,prac_result_id bigint REFERENCES ".$prefix."practice_result_tbl(practice_result_id) ON DELETE SET NULL,question_id bigint REFERENCES ".$prefix."question_tbl (question_id) ON DELETE SET NULL,answered text,is_right int,get_score int,ans_order int,CONSTRAINT ansto_order UNIQUE (ansto_whole_moshi_id, ans_order),CONSTRAINT ansto_prac UNIQUE (ansto_whole_moshi_id, prac_result_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."moshi_show_others_tbl (moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE CASCADE,usr_id bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE CASCADE) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."moshi_show_group_tbl (moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE CASCADE,class_id int REFERENCES ".$prefix."class_info_tbl (class_id) ON DELETE CASCADE,CONSTRAINT mc_link PRIMARY KEY (moshi_id, class_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_prac_tbl (uid bigint REFERENCES ".$prefix."student_tbl (student_id) , practice_id bigint REFERENCES ".$prefix."practice_tbl(practice_id), eval int, createtime datetime, CONSTRAINT upkey UNIQUE(uid, practice_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_comment_tbl (uid bigint REFERENCES ".$prefix."student_tbl (student_id) , prac_comment_id bigint REFERENCES ".$prefix."prac_comment_tbl(prac_comment_id), eval int, createtime datetime, CONSTRAINT uckey UNIQUE(uid, prac_comment_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."rec_calc_status_tbl (start_time datetime, end_time datetime,status int, admin_id bigint REFERENCES ".$prefix."teacher_tbl (teacher_id), reco_type int, include_peason int, include_flag int, include_eval int) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."flag_tanimoto_tbl (tanimoto double,uid1 bigint REFERENCES ".$prefix."student_tbl (student_id) ,uid2 bigint REFERENCES ".$prefix."student_tbl (student_id) ,create_time datetime) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_tanimoto_tbl (tanimoto double,uid1 bigint REFERENCES ".$prefix."student_tbl (student_id) ,uid2 bigint REFERENCES ".$prefix."student_tbl (student_id) ,create_time datetime) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."incor_tmp_tbl (percentage double,uid bigint,practice_id bigint,INDEX uindex(uid), INDEX pracindex(practice_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."tmp_user_avg_tbl (uid bigint primary key,avg_score double) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."tmp_prac_avg_tbl (practice_id bigint primary key,avg_score double) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."pearson_user_tbl (target1 bigint, target2 bigint, pearson_r double,create_time datetime,INDEX t1(target1), INDEX t2(target2)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."pearson_prac_tbl (target1 bigint, target2 bigint, pearson_r double,create_time datetime,INDEX t1(target1), INDEX t2(target2)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."reco_prac_tbl (uid bigint, practice_id bigint, relation double,create_time datetime,INDEX uidx(uid), INDEX pidx(practice_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."flag_prac_tanimoto_tbl (tanimoto double,practice_id1 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,practice_id2 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,create_time datetime) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_prac_tanimoto_tbl (tanimoto double,practice_id1 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,practice_id2 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,create_time datetime) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";



	} else if (DB_TYPE=="postgres7") {
		$sql = "CREATE TABLE ".$prefix."moshi_tbl (moshi_id bigint PRIMARY KEY, moshi_name text, moshi_com text, student_id bigint DEFAULT NULL REFERENCES ".$prefix."student_tbl (student_id),teacher_id bigint DEFAULT NULL REFERENCES ".$prefix."teacher_tbl( teacher_id ),difficulty int DEFAULT NULL REFERENCES ".$prefix."difficulty_tbl (difficulty_id), is_pub int DEFAULT 0,create_time timestamp,update_time timestamp,duration int,goal_score int,is_new int DEFAULT 1,moshi_type int, disp_type int DEFAULT 0, select_ans_type bigint);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE SEQUENCE ".$prefix."moshi_id_seq start 1 increment 1 maxvalue 999999999 cycle cache 1;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."moshi_quiz_type_tbl (moshi_quiz_type_id bigint PRIMARY KEY,score int,number int,type_com text,is_middle int,moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE CASCADE,department int REFERENCES ".$prefix."department_tbl (department_id) ON DELETE SET NULL,difficulty int REFERENCES ".$prefix."difficulty_tbl (difficulty_id) ON DELETE SET NULL,level int REFERENCES ".$prefix."txt_level_tbl (txt_level_id) ON DELETE SET NULL);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE SEQUENCE ".$prefix."moshi_quiz_type_id_seq start 1 increment 1 maxvalue 99999999999 cycle cache 1;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."ansto_whole_moshi_tbl (ansto_whole_moshi_id bigint PRIMARY KEY,moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE SET NULL,duration int,score int,uid bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE SET NULL,moshi_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE SEQUENCE ".$prefix."ansto_whole_moshi_id_seq start 1 increment 1 maxvalue 99999999999 cycle cache 1;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."ind_ansto_moshi_tbl (ansto_whole_moshi_id bigint REFERENCES ".$prefix."ansto_whole_moshi_tbl(ansto_whole_moshi_id) ON DELETE SET NULL,practice_id bigint REFERENCES ".$prefix."practice_tbl(practice_id) ON DELETE SET NULL,moshi_quiz_type_id bigint REFERENCES ".$prefix."moshi_quiz_type_tbl(moshi_quiz_type_id) ON DELETE SET NULL,prac_result_id bigint REFERENCES ".$prefix."practice_result_tbl(practice_result_id) ON DELETE SET NULL,question_id bigint REFERENCES ".$prefix."question_tbl (question_id) ON DELETE SET NULL,answered text,is_right int,get_score int,ans_order int,CONSTRAINT ansto_order UNIQUE (ansto_whole_moshi_id, ans_order),CONSTRAINT ansto_prac UNIQUE (ansto_whole_moshi_id, prac_result_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."moshi_show_others_tbl (moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE CASCADE,usr_id bigint REFERENCES ".$prefix."student_tbl (student_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."moshi_show_group_tbl (moshi_id bigint REFERENCES ".$prefix."moshi_tbl (moshi_id) ON DELETE CASCADE,class_id int REFERENCES ".$prefix."class_info_tbl (class_id) ON DELETE CASCADE,CONSTRAINT mc_link PRIMARY KEY (moshi_id, class_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_prac_tbl (uid bigint REFERENCES ".$prefix."student_tbl (student_id) , practice_id bigint REFERENCES ".$prefix."practice_tbl(practice_id), eval int, createtime timestamp, CONSTRAINT upkey UNIQUE(uid, practice_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_comment_tbl (uid bigint REFERENCES ".$prefix."student_tbl (student_id) , prac_comment_id bigint REFERENCES ".$prefix."prac_comment_tbl(prac_comment_id), eval int, createtime timestamp, CONSTRAINT uckey UNIQUE(uid, prac_comment_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."rec_calc_status_tbl (start_time timestamp, end_time timestamp,status int, admin_id bigint REFERENCES ".$prefix."teacher_tbl (teacher_id), reco_type int, include_peason int, include_flag int, include_eval int);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."flag_tanimoto_tbl (tanimoto double precision,uid1 bigint REFERENCES ".$prefix."student_tbl (student_id) ,uid2 bigint REFERENCES ".$prefix."student_tbl (student_id) ,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_tanimoto_tbl (tanimoto double precision,uid1 bigint REFERENCES ".$prefix."student_tbl (student_id) ,uid2 bigint REFERENCES ".$prefix."student_tbl (student_id) ,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."incor_tmp_tbl (percentage double precision,uid bigint REFERENCES ".$prefix."student_tbl (student_id),practice_id bigint REFERENCES ".$prefix."practice_tbl(practice_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."tmp_user_avg_tbl (uid bigint primary key,avg_score double precision);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."tmp_prac_avg_tbl (practice_id bigint primary key,avg_score double precision);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."pearson_user_tbl (target1 bigint REFERENCES ".$prefix."student_tbl (student_id), target2 bigint REFERENCES ".$prefix."student_tbl (student_id), pearson_r double precision,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."pearson_prac_tbl (target1 bigint REFERENCES ".$prefix."practice_tbl(practice_id), target2 bigint REFERENCES ".$prefix."practice_tbl(practice_id), pearson_r double precision,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."reco_prac_tbl (uid bigint REFERENCES ".$prefix."student_tbl (student_id), practice_id bigint REFERENCES ".$prefix."practice_tbl(practice_id), relation double precision,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."flag_prac_tanimoto_tbl (tanimoto double precision,practice_id1 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,practice_id2 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."eval_prac_tanimoto_tbl (tanimoto double precision,practice_id1 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,practice_id2 bigint REFERENCES ".$prefix."practice_tbl (practice_id) ,create_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

	}

}
unlink("../data/constant.php");
if (!make_const($db_type,$db_host,$db_name,$db_user,$db_password,$url,$prefix)) {
	$err_msg .="<br/>constant create error!";
}
if ($err_msg == "") {
	echo "Exam System is successfully upgraded. Please delete this <b>upgrade</b> Folder and <b>installer</b> Folder.<br/> ";
	echo "<a href='".$url."admin/login.php'>GO TO ADMIN LOGIN</a>";
} else {
	echo $err_msg;
}


function execute_query($statement, $db_type, $conn) {

	if ($db_type=="mysql") {
		if (!mysql_query($statement, $conn)) {
			return false;
		}
	} else if ($db_type=="postgres7") {
		if (!pg_query($conn, $statement)) {

			return false;
		}
	}
	return true;
}



function make_const($db_type,$db_host,$db_name,$db_user,$db_password,$url,$prefix) {
	//先ずは、自分のカレントディレクトリを取得
	$cur_dir =getcwd();
	//カレントから「installer/」を除いたのが、設定パス
	$direct = str_replace('upgrade','',$cur_dir);
	$direct = addslashes($direct);
	$const_contents = file_get_contents('../data/constant_dist.php');
	$const_contents = str_replace(':DB_TYPE_REP:', $db_type, $const_contents);
	$const_contents = str_replace(':DB_HOST_REP:', $db_host, $const_contents);
	$const_contents = str_replace(':DB_NAME_REP:', $db_name, $const_contents);
	$const_contents = str_replace(':DB_USER_REP:', $db_user, $const_contents);
	$const_contents = str_replace(':DB_PASS_REP:', $db_password, $const_contents);
	$const_contents = str_replace(':URL_REP:', $url, $const_contents);
	$const_contents = str_replace(':PREFIX_REP:', $prefix, $const_contents);
	$const_contents = str_replace(':DIRECT_REP:', $direct, $const_contents);
	$const_contents = str_replace(':ADMIN_LOGIN:', uniqid("admin"), $const_contents);
	$const_contents = str_replace(':STUDENT_LOGIN:', uniqid("student"), $const_contents);

	$fp = fopen('../data/constant.php','w');
	fwrite($fp, $const_contents);
	fclose($fp);
	return true;
}
?>