<?php
require_once '../data/constant.php';
$prefix = str_replace('test_txt_tbl','',TXT_TBL);
$prefix = addslashes($prefix);
$db_type = DB_TYPE;
$db_host = DB_HOST;
$db_name = DB_NAME;
$db_user = USR_NAME;
$db_password = USR_PWD;
$url = LOCAL_URL;
$err_msg="";
if (DB_TYPE=="mysql") {
//mySqlの場合
	$conn = mysql_connect(DB_HOST, USR_NAME, USR_PWD);
	$result = mysql_select_db(DB_NAME, $conn );
} else if (DB_TYPE=="postgres7") {
//postgresの場合
	$conn = pg_connect("host=".DB_HOST." dbname=".DB_NAME." user=".USR_NAME." password=".USR_PWD);
	if ($conn == false) {
		$result = false;
	} else {
		$result = true;
	}
}
if ($result == false) $err_msg = "CONNECT ERROR!";

if ($err_msg == "") {
	$sql = "ALTER TABLE ".PRACTICE_TBL." ADD is_new int default 1";
	if (!execute_query($sql, DB_TYPE, $conn)) {
		$err_msg .= "FAILED TO UPDATE question_tbl<br/>";
	}
	$sql = "ALTER TABLE ".PRACTICE_TBL." ADD exp_dur int";
	if (!execute_query($sql, DB_TYPE, $conn)) {
		$err_msg .= "FAILED TO UPDATE question_tbl<br/>";
	}

	if (DB_TYPE=="mysql") {
		$sql = "CREATE TABLE ".$prefix."practice_flag_tbl (practice_flag_id bigint PRIMARY KEY AUTO_INCREMENT,usr_id bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE CASCADE, practice_id bigint NOT NULL REFERENCES ".$prefix."practice_tbl(practice_id) ON DELETE CASCADE,department_id int REFERENCES ".$prefix."department_tbl (department_id) ON DELETE SET NULL) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."mobile_user_tbl (mobile_user_id bigint PRIMARY KEY AUTO_INCREMENT, usr_id bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE CASCADE, mobile_id character varying(200) UNIQUE, create_time datetime, update_time datetime) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."practice_show_others_tbl(practice_id bigint NOT NULL REFERENCES ".$prefix."practice_tbl(practice_id) ON DELETE CASCADE, usr_id bigint NOT NULL REFERENCES ".$prefix."student_tbl(student_id) ON DELETE CASCADE, CONSTRAINT show_other_tbl_pk UNIQUE(practice_id, usr_id)) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE TABLE ".$prefix."prac_comment_tbl (prac_comment_id bigint PRIMARY KEY AUTO_INCREMENT, prac_comment text, usr_id bigint NOT NULL REFERENCES ".$prefix."student_tbl (student_id),practice_id bigint NOT NULL REFERENCES ".$prefix."practice_tbl(practice_id),parent_comment_id bigint REFERENCES ".$prefix."prac_comment_tbl(prac_comment_id),positive int DEFAULT 0,negative int DEFAULT 0,uname text,create_time datetime, del_flag int DEFAULT 0) DEFAULT CHARACTER SET utf8;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
	} else if (DB_TYPE=="postgres7") {
		$sql = "CREATE TABLE ".$prefix."practice_flag_tbl (practice_flag_id bigint PRIMARY KEY,usr_id bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE CASCADE, practice_id bigint NOT NULL REFERENCES ".$prefix."practice_tbl(practice_id) ON DELETE CASCADE,department_id int REFERENCES ".$prefix."department_tbl (department_id) ON DELETE SET NULL);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE SEQUENCE ".$prefix."practice_flag_id_seq start 1 increment 1 maxvalue 999999999 cycle cache 1;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."mobile_user_tbl (mobile_user_id bigint PRIMARY KEY, usr_id bigint REFERENCES ".$prefix."student_tbl (student_id) ON DELETE CASCADE, mobile_id character varying(200) UNIQUE, create_time timestamp, update_time timestamp);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE SEQUENCE ".$prefix."mobile_user_id_seq start 1 increment 1 maxvalue 999999999 cycle cache 1;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."practice_show_others_tbl(practice_id bigint NOT NULL REFERENCES ".$prefix."practice_tbl(practice_id) ON DELETE CASCADE, usr_id bigint NOT NULL REFERENCES ".$prefix."student_tbl(student_id) ON DELETE CASCADE, CONSTRAINT show_other_tbl_pk UNIQUE(practice_id, usr_id));";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

		$sql = "CREATE TABLE ".$prefix."prac_comment_tbl (prac_comment_id bigint PRIMARY KEY, prac_comment text, usr_id bigint NOT NULL REFERENCES ".$prefix."student_tbl (student_id),practice_id bigint NOT NULL REFERENCES ".$prefix."practice_tbl(practice_id),parent_comment_id bigint REFERENCES ".$prefix."prac_comment_tbl(prac_comment_id),positive int DEFAULT 0,negative int DEFAULT 0,uname text,create_time timestamp, del_flag int DEFAULT 0);";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";
		$sql = "CREATE SEQUENCE ".$prefix."prac_comment_id_seq start 1 increment 1 maxvalue 999999999 cycle cache 1;";
		if (!execute_query($sql, DB_TYPE, $conn)) $err_msg .= "EXECUTE_ERR";

	}

}
unlink("../data/constant.php");
if (!make_const($db_type,$db_host,$db_name,$db_user,$db_password,$url,$prefix)) {
	$err_msg .="<br/>constant create error!";
}
if ($err_msg == "") {
	echo "Exam System is successfully upgraded. Please delete this <b>upgrade</b> Folder and <b>installer</b> Folder.<br/> ";
	echo "<a href='".$url."admin/login.php'>GO TO ADMIN LOGIN</a>";
} else {
	echo $err_msg;
}



function create_tbl_query($basic,$prefix, $db_type, $start, $conn) {
	//テーブルCREATE
	$cr_tbl_sql = "CREATE TABLE ".$prefix.$basic."_tbl (".$basic."_id int PRIMARY KEY ";
	if ($db_type=="mysql") $cr_tbl_sql .="AUTO_INCREMENT";
	$cr_tbl_sql .= ", ".$basic."_nam TEXT NOT NULL, comment TEXT);";

	if (!execute_query($cr_tbl_sql, $db_type, $conn)) return false;
	if ($db_type=="postgres7") {
		$cr_seq_sql = "CREATE SEQUENCE ".$prefix.$basic."_id_seq start ".$start." increment 1 maxvalue 99999 cycle cache 1;";
		if (!pg_query($conn, $cr_seq_sql)) return false;
	}
	return true;
}

function execute_query($statement, $db_type, $conn) {
	if ($db_type=="mysql") {
		if (!mysql_query($statement, $conn)) return false;
	} else if ($db_type=="postgres7") {
		if (!pg_query($conn, $statement)) return false;
	}
	return true;
}



function make_const($db_type,$db_host,$db_name,$db_user,$db_password,$url,$prefix) {
	//先ずは、自分のカレントディレクトリを取得
	$cur_dir =getcwd();
	//カレントから「installer/」を除いたのが、設定パス
	$direct = str_replace('upgrade','',$cur_dir);
	$direct = addslashes($direct);
	$const_contents = file_get_contents('../data/constant_dist.php');
	$const_contents = str_replace(':DB_TYPE_REP:', $db_type, $const_contents);
	$const_contents = str_replace(':DB_HOST_REP:', $db_host, $const_contents);
	$const_contents = str_replace(':DB_NAME_REP:', $db_name, $const_contents);
	$const_contents = str_replace(':DB_USER_REP:', $db_user, $const_contents);
	$const_contents = str_replace(':DB_PASS_REP:', $db_password, $const_contents);
	$const_contents = str_replace(':URL_REP:', $url, $const_contents);
	$const_contents = str_replace(':PREFIX_REP:', $prefix, $const_contents);
	$const_contents = str_replace(':DIRECT_REP:', $direct, $const_contents);
	$const_contents = str_replace(':ADMIN_LOGIN:', uniqid("admin"), $const_contents);
	$const_contents = str_replace(':STUDENT_LOGIN:', uniqid("student"), $const_contents);

	$fp = fopen('../data/constant.php','w');
	fwrite($fp, $const_contents);
	fclose($fp);
	return true;
}
?>