<?php
/*2012/12/31
 * ¦顢桼θå
 */

require_once '../../data/constant.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';
require_once '../../data/data_for_test.php';
require_once '../../data/data_for_group.php';

require_once '../../util/make_item.php';
require_once '../../util/for_practice.php';
require_once '../../util/change_util.php';

require_once '../../util/for_moshi.php';

session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}
//
$admin_nam ="";
$admin_status ="";
$admin_id="";
$ses_list = $_SESSION[SESSION_ADMIN];
$err_msg = "";

if ($ses_list['status'] == 0) {
	$admin_status =$ses_list['status'];
	$admin_id=$ses_list['teacher_id'];
	$admin_nam =$ses_list['teacher_nam'];
} else {
	$admin_status =$ses_list['status'];
	$admin_id=$ses_list['teacher_id'];
}

$practice_id = "";
$question_id = "";

$edit_disp = "none";

$prac_list_txt = "no data";
$is_already_flaged ="";
$flag_submit_label ="";
$show_other_disp = "none";
$shared_emad_disp = "no data";
$comment_list = "";
$comment_navi = "";
$analysis_list = "";
$prac_disp = "inline";
$text_id = "";

$history="";
$bunpu = "";

if (isset($_REQUEST['practice_id']) && is_numeric($_REQUEST['practice_id'])){
	$practice_id = $_REQUEST['practice_id'];
}


$st_id = "";
if (isset($_GET["uid"]) && is_numeric($_GET["uid"])) {
	$st_id = $_GET["uid"];
}
$class_id = "";
if (isset($_GET["class_id"]) && is_numeric($_GET["class_id"])) {
	$class_id = $_GET["class_id"];
}



if ($practice_id == "" || $st_id == "" || $class_id == "") {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}


$practice_title = "";
$practice_txt = "";
$answer = "";
$dep = "";
$dep_name="";
$lev = "";
$lev_name="";
$dif = "";
$dif_name="";
$status = "";
$comment = "";
$err_msg = "";
$img_file = "";
$img_url = "";
$is_file_input_display = "inline";
$is_file_exist_display ="none";

$is_avfile_input_display = "inline";
$is_avfile_exist_display ="none";
$av_file ="";
$av_url = "";

$key_word_arr = array();
$item_bango_arr = array();
$item_txt_arr = array();
$item_is_right_arr = array();

$student_nam = "";
$creater_disp = "";
$data_object = new CDbAccess();
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {

	$class_data_object = new CClassInfoTableAccess();
	$data = $class_data_object->getOneClass($data_object->conn, $class_id);
	if ($data == false) {
		$err_msg = "Class data was not found.";
	} else {

		if ($admin_status <>1 && $data["teacher_id"] <> $admin_id) {
			header("Content-Type: text/html; charset=EUC-JP");
			header(URL_SET."admin/login.php");
			exit;
		}
		//$class_nam = htmlspecialchars($data['class_nam'],ENT_QUOTES);
	}

	//桼̾
	$st_inc_object = new CStudentInClassAccess();
	$st_data = $st_inc_object->getAndCheckMember($data_object->conn, $class_id, $student_id);
	if (!$st_data) {
		header("Content-Type: text/html; charset=EUC-JP");
		header(URL_SET."admin/login.php");
		exit;
	}

	$student_nam = htmlspecialchars($st_data["student_nam"],ENT_QUOTES);

	$practice_object = new CPracTableAccess();
	if ($practice_id <> "") {
		$practice_data = $practice_object->getDetailPracticeData($data_object->conn,$practice_id);
		if ($practice_data == false) {
			$err_msg .= "No Data Found";
		} else {
			$answer = intval($practice_data['answer']);
			$department_id = intval($practice_data['department']);
			$level_id = intval($practice_data['level']);
			$practice_title = htmlspecialchars($practice_data['practice_title'],ENT_QUOTES);
			$practice_text = source2Html($practice_data['practice_text']);
			$difficulty =intval($practice_data['exp_dif']);
			$status = intval($practice_data['status']);
			$comment = source2Html($practice_data['comment']);
			$cre_student_id = intval($practice_data['cre_student_id']);

			$img_file = $practice_data["img_file"];
			if ($img_file <> "") {

				$img_url ="<img src='".LOCAL_URL."img_files/prac_".$practice_id."/".$img_file."' width='300' height='200' />";
			}
			$img_url .= "<br/>";

			$av_file = $practice_data['av_file'];
			if ($av_file <> "" && $av_file <> null) {
				$av_url ="<embed src='".LOCAL_URL."av_files/prac_".$practice_id."/".$av_file."' width='300' height='200' />";
			}
			$av_url .= "<br/>";

			$question_id = intval($practice_data['parent_question']);
			//if ($answer == 0) {
			if ($answer == 0 || $answer == 5 || $answer == 6) {
				$key_word_object = new CPracKeyWordTableAccess();
				if ($key_word_object->setKeyWordPerPracticeArr($data_object->conn, $practice_id)) {
					while ($key_word_data = $key_word_object->dbFetchArr()) {
						array_push($key_word_arr, htmlspecialchars($key_word_data['key_word_txt'],ENT_QUOTES));

					}
					$key_word_object->dbFreeResult();
				}

				$is_keyword_display = "inline";
				$is_item_display = "none";
			} else if ($answer == 1 || $answer == 2) {
				$item_object = new CPracItemTableAccess();
				if ($item_object->setItemPerPracticeArr($data_object->conn, $practice_id)) {
					while ($item_data = $item_object->dbFetchArr()) {
						array_push($item_bango_arr,htmlspecialchars($item_data['item_order'],ENT_QUOTES));
						array_push($item_txt_arr,htmlspecialchars($item_data['item_txt'],ENT_QUOTES));
						array_push($item_is_right_arr,$item_data['is_right']);
					}
					$item_object->dbFreeResult();
				}
				$is_keyword_display = "none";
				$is_item_display = "inline";
			}

		}

		$start_id = 0;
		if (isset($_GET['pgid']) && is_numeric($_GET['pgid'])) {
			$start_id = $_GET['pgid'];
		}
		$prac_com_object = new CPracticeComment();
		$prac_com_object->setCommentList($data_object->conn,$practice_id,$start_id,0);
		$comment_list = $prac_com_object->getCommentList();

		if (is_numeric($cre_student_id)) {
			$student_object = new CStudentTableAccess();
			$st_data = $student_object->getOneStudent($data_object->conn, $cre_student_id);
			if ($st_data <> false) {
				$creater_disp = htmlspecialchars($st_data["student_nam"],3)._EXAM_COMMON_PRACTICE_MAKE_USR;
			}
		}

		//˺줿
		if ($practice_object->setPracFromPrac ($data_object->conn, $practice_id)) {
			while ($result = $practice_object->dbFetchArr()) {
				$prac_list_txt .= htmlspecialchars($result['practice_title'],ENT_QUOTES)."<p/>";
				//$prac_list_txt .= nl2br(htmlspecialchars($result['practice_text'],ENT_QUOTES))."<p/>";
				$prac_list_txt .= source2Html($result['practice_text'])."<p/>";
				if ($result['img_file'] <> "") {
					$prac_list_txt .="<img src='".LOCAL_URL."img_files/prac_".$result['practice_id']."/".$result['img_file']."' width='300' height='200' /><br/>";
				}
				if ($result['av_file'] <> "" && $result['av_file'] <> null) {
					$prac_list_txt .="<embed src='".LOCAL_URL."av_files/prac_".$result['practice_id']."/".$result['av_file']."' width='300' height='200' /><br/>";
				}

				if ($result['answer'] == 0 || $result['answer'] == 5) {
					$prac_list_txt .= "<input type='text' size=50/><br/>";
				} else if ($result['answer'] == 1 || $result['answer'] == 2) {
					$item_object = new CPracItemTableAccess();
					if ($item_object->setItemPerPracticeArr($data_object->conn, $result['practice_id'])) {
						while ($item_data = $item_object->dbFetchArr()) {
							if ($result['answer'] == 1) {
								$prac_list_txt .= "<input type='radio'/>";
							} else {
								$prac_list_txt .= "<input type='checkbox'/>";
							}
							$prac_list_txt .= "<b>".htmlspecialchars($item_data['item_order'],ENT_QUOTES)."</b> ";
							//$prac_list_txt .= htmlspecialchars($item_data['item_txt'],ENT_QUOTES)."<br/>";
							$prac_list_txt .= source2Html($item_data['item_txt'])."<br/>";

						}
						$item_object->dbFreeResult();
					}
				}
				$prac_list_txt .= "<p/><hr width = '90%' align='center'/>";
			}
			$practice_object->dbFreeResult();
		}
		//ʬ
		$prac_ana_object = new CPracAnalysis();
		if (!$prac_ana_object->setPracInfo($data_object->conn, $practice_id,$st_id)) {
			$analysis_list = "No Data";
		} else {
			$prac_ana_object->setUsrShowList();
			$analysis_list = $prac_ana_object->getUsrShowList();
			$history = $prac_ana_object->getHistory();

		}
		//ʬ
		$prac_result_object = new CPracResTableAccess();
		if ($prac_result_object->setBunpuOfOnePrac($data_object->conn, $practice_id)) {
			while ($res = $prac_result_object->dbFetchArr()) {
				$bunpu .= "<tr><td>";
				$bunpu .= htmlspecialchars($res["answered"],3);
				if ($res["is_right"] == 1) {
					$bunpu .= "("._EXAM_STU_PRACTICE_RIGHT.")";
				}
				$bunpu .= "<br/></td><td>".$res["cnt"]."</td></tr>";
			}
			$prac_result_object->dbFreeResult();
		}

	}

	$dep_object = new CDepartmentTableAccess();
	$dep_data = $dep_object->getDetailDepartmentData($data_object->conn, $department_id);
	if ($dep_data <> false) {
		$dep_name = htmlspecialchars($dep_data['department_nam'],ENT_QUOTES);
	} else {
		$dep_name = _COMMON_NOTSET_TXT;
	}

	$dif_object = new CDifficultyTableAccess();
	$dif_data = $dif_object->getDetailDifficData($data_object->conn, $difficulty);
	if ($dif_data <> false) {
		$dif_name = htmlspecialchars($dif_data['difficulty_nam'],ENT_QUOTES);
	} else {
		$dif_name = _COMMON_NOTSET_TXT;
	}

	$lev_object = new CTxtLevelTableAccess();
	$lev_data = $lev_object->getDetailTxtLevelData($data_object->conn, $level_id);
	if ($lev_data <> false) {
		$lev_name = htmlspecialchars($lev_data['txt_level_nam'],ENT_QUOTES);
	} else {
		$lev_name = _COMMON_NOTSET_TXT;
	}

	$data_object->closeDB();
}

$show_data = file_get_contents(TEMPLATE_DIR.'ad_analyze/usr_prac_info.tpl');
$show_data = str_replace(':ERR_MSG:', mb_convert_encoding($err_msg,'UTF-8', 'EUC-JP'), $show_data);

$show_data = str_replace(':PRAC_TITLE_TXT:', $practice_title, $show_data);
$show_data = str_replace(':PRAC_TXT_REP:', $practice_text, $show_data);

$show_data = str_replace(':ANS_TYPR_REP:', $QUEST_TYPE_ARR2[$answer], $show_data);


$show_data = str_replace(':DEP_SEL_REP:', $dep_name, $show_data);
$show_data = str_replace(':LEV_SEL_REP:', $lev_name, $show_data);
$show_data = str_replace(':DIF_SEL_REP:', $dif_name, $show_data);

for ($i=0; $i<3; $i++) {
	$selected = "";
	if ($status === $i) $selected = "SELECTED";
	$show_data = str_replace(":ST_SELECTED_REP".$i.":", $selected, $show_data);
}
$show_data = str_replace(':COMMENT_REP:', $comment, $show_data);

for ($i=0; $i<10; $i++) {
	$key_word_txt = "";
	if (isset($key_word_arr[$i])) $key_word_txt = $key_word_arr[$i];
	$show_data = str_replace(':KEY_WORD'.$i.'_REP'.$i.':', $key_word_txt, $show_data);
}

for ($i=0; $i < 10; $i++) {
	$item_order = "";
	$item_txt = "";
	$is_right = 0;
	if (isset($item_bango_arr[$i])) {
		$item_order = $item_bango_arr[$i];
		$item_txt = $item_txt_arr[$i];
		$is_right = $item_is_right_arr[$i];
	}
	$show_data = str_replace(':BANGO_REP'.$i.':', $item_order, $show_data);
	$show_data = str_replace(':ITEM_TXT_REP'.$i.':', $item_txt, $show_data);
	if ($is_right == 1) {
		$show_data = str_replace(':IS_RIGHT'.$i.'_REP:', "CHECKED", $show_data);
	} else {
		$show_data = str_replace(':IS_RIGHT'.$i.'_REP:', "", $show_data);
	}
}


$show_data = str_replace(':KEY_WORD_DISPLAY_REP:', $is_keyword_display, $show_data);
$show_data = str_replace(':ITEM_DISPLAY_REP:', $is_item_display, $show_data);

$show_data = str_replace(':PRA_ID_REP:', $practice_id, $show_data);

$show_data = str_replace(':IMG_VIEW_REP:', $img_url, $show_data);
$show_data = str_replace(':EXIST_FILE_NAME_REP:', $img_file, $show_data);

$show_data = str_replace(':PRAC_LIST_REP:', $prac_list_txt, $show_data);
$show_data = str_replace(':COMMENT_LIST_REP:', $comment_list, $show_data);
$show_data = str_replace(':ANALYSIS_LIST_REP:', $analysis_list, $show_data);
$show_data = str_replace(':CREATER_DISP_REP:', $creater_disp, $show_data);
$show_data = str_replace(':PRAC_DISP_REP:', $prac_disp, $show_data);
$show_data = str_replace(':TEXT_ID_REP:', $text_id, $show_data);
$show_data = str_replace(':ANA_HISTORY_REP:', $history, $show_data);
$show_data = str_replace(':ANA_BUNPU_REP:', $bunpu, $show_data);

$show_data = str_replace(':AV_VIEW_REP:', $av_url, $show_data);
$show_data = str_replace(':EXIST_AVFILE_NAME_REP:', $av_file, $show_data);
$show_data = str_replace(':STUDENT_NAM_REP:', $student_nam, $show_data);

echo $show_data;

?>