<?php
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../util/validate.php';
require_once '../../data/db_access.php';
require_once '../../data/table_access.php';

session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."admin/login.php");
	exit;
}
$ses_arr = $_SESSION[SESSION_ADMIN];
$text_id = "";
$action_type ="";
$q_id = "";
$up_tbl_txt = "";
$err_msg = "";
$up_button_txt="";
$ins_tbl_txt="";
$item_count = 0;
$checked_txt="";

//źեեϢ
$img_conf="";
$av_set="";

$av_conf="";
$url_img = LOCAL_URL."img_files/";
$url_av = LOCAL_URL."av_files/";
$write_av = DOC_ROOT."av_files/";

if ($_GET <> null) {
	unset($_FILES);
	if (isset($_GET['text_id'])) {
		$text_id = $_GET['text_id'];
	}
	if (isset($_GET['question_id'])) {
		$q_id = $_GET['question_id'];
	}
	if (!is_numeric($text_id) || !is_numeric($q_id)) {
		header("Content-Type: text/html; charset=EUC-JP");
		header(URL_SET."admin/txt_make/list.php");
		exit;
	}
}
if ($_POST <> null) {
	$action_type = $_POST['action_type'];
}
$data_object = new CDbAccess();
		//DB³
if ($data_object->openDB() == false) {
	$err_msg .= $data_object->err_msg;
} else {
	//ƥǡΥ֥Ȥ
	$item_data_object = new CItemTableAccess ();
	//ǡΥ֥Ȥ
	$q_data_object = new CQuestionTableAccess ();

	if ($text_id == null || $text_id == "") {
	//ƥID򽦤äƤ餺Υեफǡ
		if ($action_type == "insert") {
			$q_id = $_POST['question_id'];
			$val_object =new validator();
			$val_object->setFormType('item_make');
			$val_object->setErrMsg($_POST);
			if ($val_object->err_msg == "") {
				if (!$item_data_object->insertItemDataExe($data_object->conn, $_POST)) {
					$err_msg = "<font color='red'>"._EXAM_TEA_OPTION_INSERT_ERR."</font>";
				}
			} else {
				$err_msg = $val_object->err_msg;
			}
			$text_id = $_POST['text_id'];
		} else if ($action_type = "av_set") {
//AVեι
			$text_id = $_POST['text_id'];
			$q_id = $_POST['question_id'];
			//SQL
			$tmp_qav = "";
			$tmp_qrep = 1;
			//ǥ쥯ȥ
			$write_av .= $text_id;
			if (!is_dir($write_av)) {
				mkdir($write_av,0777);
			}
			$write_av .= "/".$q_id;
			if ($_POST['question_repeat'] <> "" && !is_numeric($_POST['question_repeat'])) {
	//ĤʤΤǡ٤񤭤
				$err_msg = "<font color='red'>"._EXAM_TEA_AV_REPEAT._EXAM_VALIDATE_NUMERIC_ERR."</font>";
			} else {
				if ($_POST['question_repeat'] <> "") {
					$tmp_qrep = $_POST['question_repeat'];
				}
				//av񤭹
				//print $file_nam;
				//if ( $_FILES['question_av_file']['name'] <> "") {
				if (array_key_exists('question_av_file', $_FILES) == true) {
					if (!mb_eregi("\.asf|\.wma|\.wmv|\.asx|\.wax|\.wvx|\.cda|\.mid|\.midi|\.wav|\.snd|\.au|\.aif|\.aifc|\.aiff|\.avi|\.mpg|\.mpeg|\.mp3|\.mov|\.swf|\.flv$",$_FILES['question_av_file']['name'])) {
//					if (!ereg("\.mid|\.midi|\.wav|\.au$",$_FILES['question_av_file']['name'])) {
						$err_msg = "<font color='red'>"._EXAM_TEA_UNSUPPORTED_AV_ERR."</font>";
					} else{
						if (!is_dir($write_av)) {
						mkdir($write_av,0777);
						}
						if (!move_uploaded_file($_FILES['question_av_file']['tmp_name'], $write_av."/".basename($_FILES['question_av_file']['name']))) {
							$err_msg ="<font color='red'>"._EXAM_TEA_AV_COPY_ERR."</font>";
						} else {
							$tmp_qav = $_FILES['question_av_file']['name'];
						}
					}
				} else {
					if ($_POST['av_del'] == "" || $_POST['av_del'] == null) {
						$tmp_qav = $_POST['question_av_file'];
					}
				}
			}
			if ($err_msg == "") {
				//ǡ򹹿
				if (!$q_data_object->updateQuestionAvExe($data_object->conn, $q_id, $tmp_qav, $tmp_qrep, $ses_arr['teacher_id'])) {
					$err_msg .="<font color='red'>"._EXAM_TEA_AV_COPY_ERR."</font>";
					$err_msg .=$q_data_object->err_msg;
				} else {
					unset($_FILES);
					header("Content-Type: text/html; charset=EUC-JP");
					header(URL_SET."admin/question_make/question_list.php?text_id=".$text_id);
					exit;
				}
			}
		}

	}
	//ƥȥǡΥ֥Ȥ
	$text_object = new CTextTableAccess();

	$txt_data = $text_object->getDetailTextData($data_object->conn, $text_id);
	if ($txt_data == false) {
		$text_title = _COMMON_DB_NODATA_FOUND;
		$text_cont = _COMMON_DB_NODATA_FOUND;
	} else {
//		$text_title = htmlspecialchars(mb_convert_encoding($txt_data['text_title'],'EUC-JP','UTF-8'),ENT_QUOTES);
//		$text_cont = nl2br(htmlspecialchars(mb_convert_encoding($txt_data['content'],'EUC-JP','UTF-8'),ENT_QUOTES));
		$text_title = htmlspecialchars($txt_data['text_title'],ENT_QUOTES);
		$text_cont = nl2br(htmlspecialchars($txt_data['content'],ENT_QUOTES));
		if ($txt_data['img_file']==null || $txt_data['img_file']=="") {
			$img_conf = "";
		} else {
			$img_conf = "<img border=0 src='".$url_img.$text_id."/".$txt_data['img_file']."'>";
		}

		if ($txt_data['av_file'] == "" || $txt_data['av_file'] == null) {
			$av_conf ="";
		} else {
			$av_conf = "<a href='../question_make/view_tmp.php?text_id=".$text_id."&repeat=".$txt_data['av_repeat']."&av_file=".$txt_data['av_file']."' target='_blank'>"._EXAM_TEA_OPTIONAL_AV."</a>";
		}
	}

	//μ
	$q_data = $q_data_object->getQuestionDetail($data_object->conn, $q_id);
	if ($q_data == false) {
		$q_cont = _COMMON_DB_NODATA_FOUND;
	} else {
//		$q_cont = nl2br(htmlspecialchars(mb_convert_encoding($q_data['content'],'EUC-JP','UTF-8'),ENT_QUOTES));
		$q_cont = nl2br(htmlspecialchars($q_data['content'],ENT_QUOTES));
		$q_ans = $q_data['answer'];
		if ($q_ans == 1) {
			$q_ans_text = _EXAM_TEA_SINGLE_ANS_TXT;
		} else if ($q_ans == 2) {
			$q_ans_text = _EXAM_TEA_MULTI_ANS_TXT;
		}
	//ҥ
		if ($q_data['question_av_file'] == "" || $q_data['question_av_file'] == null) {
			$av_set .="<input type='hidden' name='MAX_FILE_SIZE' value='30000000' />";
			$av_set .="<input type = 'file' name='question_av_file' size=42><br>";
		} else {
			$av_set .= "<input type='checkbox' name='av_del' value='1'> ";
			$av_set .= "<a href='../question_make/view_tmp.php?text_id=".$text_id."&question_id=".$q_id."&repeat=".$q_data['question_repeat']."&av_file=".$q_data['question_av_file']."' target='_blank'>"._EXAM_TEA_OPTIONAL_AV._EXAM_TEA_ALREADY_AV;
			$av_set .= _EXAM_TEA_AV_NOT_USE;
			$av_set .= "<input type='hidden' name ='question_av_file' value='".$q_data['question_av_file']."'><br>";
		}
		$av_set .="<b>"._EXAM_TEA_AV_REPEAT.":</b> <input type='text' name='question_repeat' value='".$q_data['question_repeat']."' size=1 maxlength=1>";
		$av_set .="<input type='hidden' name='question_id' value=".$q_id.">";
		$av_set .="<input type='hidden' name='text_id' value=".$text_id.">";
	}

	//ΥꥹȤ
	$data_list = $item_data_object->getItemPerQuestion($data_object->conn, $q_id);
	$already_checked = 0;
	if (!$data_list) {
		$up_tbl_txt ="<td colspan=4>"._COMMON_DB_NODATA_FOUND."</td>";
	} else {
//		if (count($data_list) == 0) {
//			$up_tbl_txt = "<td colspan=4>ǡϿƤޤ</td>";
//		} else {
			$counting = 1;

			foreach($data_list as $data_arr) {
				//å
				$is_right_ch = "";
				if ($data_arr['is_right'] == 1) {
					$is_right_ch = _EXAM_TEA_OPTION_RIGHT_ANS;
					if ($q_ans == 1) {
						$already_checked = 1;
					}
				} else {
					$is_right_ch = "<br/>";
				}
				$up_tbl_txt .= "<tr><td>";
				$up_tbl_txt .= "<a href='mod_item.php?question_id=".$q_id."&text_id=".$text_id."&order=".urlencode($data_arr['item_order'])."'>";
//				$up_tbl_txt .= htmlspecialchars(mb_convert_encoding($data_arr['item_order'],'EUC-JP','UTF-8'),ENT_QUOTES)."</a></td>";
				$up_tbl_txt .= htmlspecialchars($data_arr['item_order'],ENT_QUOTES)."</a></td>";
				$up_tbl_txt .= "<td>";
//				$up_tbl_txt .= htmlspecialchars(mb_convert_encoding($data_arr['item_txt'],'EUC-JP','UTF-8'),ENT_QUOTES)."<br/></td>";
//				$up_tbl_txt .= "<td>".htmlspecialchars(mb_convert_encoding($data_arr['comment'],'EUC-JP','UTF-8'),ENT_QUOTES)."<br/></td>";
				$up_tbl_txt .= htmlspecialchars($data_arr['item_txt'],ENT_QUOTES)."<br/></td>";
				$up_tbl_txt .= "<td>".htmlspecialchars($data_arr['comment'],ENT_QUOTES)."<br/></td>";
				$up_tbl_txt .= "<td>".$is_right_ch."</td>";
	//		}

		}
	}
	if ($already_checked<>1) {
		$checked_txt = "<input type='checkbox' name='is_right' value=1>";
	} else {
		$checked_txt = "<br/>";
	}
	$data_object->closeDB();
}
/*
$show_data = file_get_contents('../../templates/ad_item_make/item_form.tpl');
$show_data = ereg_replace(':TEXT_ID_REP:', $text_id, $show_data);
$show_data = ereg_replace(':ERR_MSG:', mb_convert_encoding($err_msg,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':TITLE_REP:', mb_convert_encoding($text_title,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':TEXT_REP:', mb_convert_encoding($text_cont,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':IMG_CONF:', mb_convert_encoding($img_conf,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':AV_CONF:', mb_convert_encoding($av_conf,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':AV_SET:', mb_convert_encoding($av_set,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':Q_TEXT_REP:', mb_convert_encoding($q_cont,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':Q_TYPE_REP:', mb_convert_encoding($q_ans_text,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':UP_TABLE_REP:', mb_convert_encoding($up_tbl_txt,'UTF-8', 'EUC-JP'), $show_data);
$show_data = ereg_replace(':Q_ID_REP:', $q_id, $show_data);
$show_data = ereg_replace(':CHECKED_REP:', $checked_txt, $show_data);
*/
$show_data = file_get_contents(TEMPLATE_DIR.'ad_item_make/item_form.tpl');
$show_data = str_replace(':TEXT_ID_REP:', $text_id, $show_data);
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':TITLE_REP:', $text_title, $show_data);
$show_data = str_replace(':TEXT_REP:', $text_cont, $show_data);
$show_data = str_replace(':IMG_CONF:', $img_conf, $show_data);
$show_data = str_replace(':AV_CONF:', $av_conf, $show_data);
$show_data = str_replace(':AV_SET:', $av_set, $show_data);
$show_data = str_replace(':Q_TEXT_REP:', $q_cont, $show_data);
$show_data = str_replace(':Q_TYPE_REP:', $q_ans_text, $show_data);
$show_data = str_replace(':UP_TABLE_REP:', $up_tbl_txt, $show_data);
$show_data = str_replace(':Q_ID_REP:', $q_id, $show_data);
$show_data = str_replace(':CHECKED_REP:', $checked_txt, $show_data);

echo $show_data;
?>