<?php
require_once("../language/japanese.php");

error_reporting(E_ERROR);
//å򥯥ꥢ
ini_set("session.save_handler","files");
session_start();
if (!isset($_SESSION["install_info"])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header("Location: http://localhost/");
	exit;	
}
$session_array = $_SESSION["install_info"];

$err_msg = "";
$tmp_sql = "";
$const_contents = "";
$is_able="";
$prefix = $session_array['pre_fix'];
$db_type = $session_array['db_type'];
$db_host = $session_array['db_host'];
$db_name = $session_array['db_name'];
$db_user = $session_array['db_user'];
$db_password = $session_array['db_password'];
$url = $session_array['url'];

if ($db_type == "mysql") {
//mySqlξ
	$conn = mysql_connect($db_host,$db_user,$db_password);
	if ($conn == true) {
		if (!mysql_select_db(mysql_real_escape_string($db_name), $conn)) {
			$err_msg .= _INSTALL_ERR_DB_UNUSEABLE1.$_POST['db_name']._INSTALL_ERR_DB_UNUSEABLE2;
		} else {
			$tables = mysql_list_tables(mysql_real_escape_string($db_name), $conn);
			while($table_name = mysql_fetch_array($tables)) {
				if (substr($table_name[0], 0, strlen($prefix)) == $prefix) {
					$err_msg = $prefix._INSTALL_ERR_DB_PREFIX;
					break;
				}
			}
		}
		mysql_close($conn);
	} else {
		$err_msg = _INSTALL_ERR_DB_UNCONNECTABLE;
	}
} else if ($db_type == "postgres") {
//postgresξ
	$conn = pg_connect("host=".$db_host." dbname=".$db_name." user=".$db_user." password=".$db_password);
	if ($conn == false) {
		$err_msg = _INSTALL_ERR_DB_UNCONNECTABLE;
	} else {

		$try_sql = "SELECT COUNT(relname) FROM pg_class WHERE ";
		$try_sql .= "(relkind = 'r' OR relkind ='i' OR relkind = 'S') AND relname LIKE '".pg_escape_string($prefix)."%'";
		$rows = pg_query($conn, $try_sql);
		$result = pg_fetch_array($rows);
		if ($result <> false) {
			if ($result[0] <> 0) {
				$err_msg = $prefix._INSTALL_ERR_DB_PREFIX;
			}
		}
		pg_close($conn);
	}
}


if (file_get_contents('../data/constant_dist.php') ==false) {
	$err_msg .= _INSTALL_ERR_NO_CONSTANT_FILE;
}
if (!is_writable('../data/')) {
	$err_msg .= _INSTALL_ERR_CONSTANT_FILE_NOT_WRITABLE;
}

if ($db_type == "mysql") {
	if (file_get_contents('./db_file_mysql.txt')==false) {
		$err_msg .= _INSTALL_ERR_NO_DB_FILE;
	}
}
if ($db_type == "postgres") {
	if (file_get_contents('./db_file_postgres.txt')==false) {
		$err_msg .= _INSTALL_ERR_NO_DB_FILE;
	}
}

if ($err_msg <> "") {
	$is_able = "DISABLED";
}

$show_data = file_get_contents('../templates/installer/install_confirm.tpl');
/*
$show_data = ereg_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = ereg_replace(':DB_TYPE_REP:', $db_type, $show_data);
$show_data = ereg_replace(':DB_HOST_REP:', $db_host, $show_data);
$show_data = ereg_replace(':DB_NAME_REP:', $db_name, $show_data);
$show_data = ereg_replace(':DB_USER_REP:', $db_user, $show_data);
$show_data = ereg_replace(':DB_PASS_REP:', $db_password, $show_data);
$show_data = ereg_replace(':URL_REP:', $url, $show_data);
$show_data = ereg_replace(':PREFIX_REP:', $prefix, $show_data);
$show_data = ereg_replace(':IS_ABLE:', $is_able, $show_data);
*/
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':DB_TYPE_REP:', $db_type, $show_data);
$show_data = str_replace(':DB_HOST_REP:', $db_host, $show_data);
$show_data = str_replace(':DB_NAME_REP:', $db_name, $show_data);
$show_data = str_replace(':DB_USER_REP:', $db_user, $show_data);
$show_data = str_replace(':DB_PASS_REP:', $db_password, $show_data);
$show_data = str_replace(':URL_REP:', $url, $show_data);
$show_data = str_replace(':PREFIX_REP:', $prefix, $show_data);
$show_data = str_replace(':IS_ABLE:', $is_able, $show_data);

echo $show_data;
?>